function [adjMatrix] = makeAdjMatrix(segs,rho_max,theta_max)

nL = length(segs);
adjMatrix = cell(nL,1);
num_neighbors = 3;

for i=1:nL  
   
    for j=i+1:nL
        
        [rho, theta, st] = isAdjacent(segs(i),segs(j),rho_max,theta_max);
        if (rho~=-1)
            ind = size(adjMatrix{i}, 1)+1;
            adjMatrix{i}(ind, 1) = j;
            adjMatrix{i}(ind, 2) = rho;
            adjMatrix{i}(ind, 3) = theta;
            adjMatrix{i}(ind, 4) = st;           
            
            ind = size(adjMatrix{j}, 1)+1;
            adjMatrix{j}(ind, 1) = i;
            adjMatrix{j}(ind, 2) = rho;
            adjMatrix{j}(ind, 3) = theta;
            adjMatrix{j}(ind, 4) = 1-st;     
            
        end
    end
end



for i=1:nL
    mat = adjMatrix{i};
    if(~size(mat,1))
        continue;
    end
    mat1 = mat(mat(:,4)==1,:);
    mat2 = mat(mat(:,4)==0,:);
    
    if(size(mat1,1)>num_neighbors)
        temp = mat1;
        [~, ids] = sort(temp(:,2));
        mat1 = temp(ids(1:num_neighbors),:);
        
        for j=num_neighbors+1:length(ids)
            j_ = temp(ids(j),1);
            index = find(adjMatrix{j_}(:,1)==i);
            adjMatrix{j_}(index,:) = [];
        end
    end
    
    if(size(mat2,1)>num_neighbors)
        temp = mat2;
        [~, ids] = sort(temp(:,2));
        mat2 = temp(ids(1:num_neighbors),:);
        
        for j=num_neighbors+1:length(ids)
            j_ = temp(ids(j),1);
            index = find(adjMatrix{j_}(:,1)==i);
            adjMatrix{j_}(index,:) = [];
        end
    end
    
    adjMatrix{i} = [mat1; mat2];
end